﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.ComponentModel;

namespace SL_ComboBox_WatermarkinBoundMode
{
    public partial class MainPage : UserControl, INotifyPropertyChanged
    {
        private ObservableCollection<KeyValuePair<string, string>> _dropDownValues = new ObservableCollection<KeyValuePair<string, string>>();
        
        public ObservableCollection<KeyValuePair<string, string>> DropDownValues
        {
            get
            {
                return _dropDownValues;
            }

            set
            {
                _dropDownValues = value;
                OnPropertyChanged("DropDownValues");
            }
        }

        private string _selectedValue;

        public string SelectedValue
        {
            get
            {
                return _selectedValue;
            }

            set
            {
                _selectedValue = value;
                OnPropertyChanged("SelectedValue");
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        protected void OnPropertyChanged(string propertyName)
        {
            PropertyChangedEventHandler handler = PropertyChanged;

            if (handler != null)
            {
                handler(this, new PropertyChangedEventArgs(propertyName));
            }
        }

        public MainPage()
        {
            InitializeComponent();

            DataContext = this;

            DropDownValues.Add(new KeyValuePair<string, string>("672", "Jim Smith"));
            DropDownValues.Add(new KeyValuePair<string, string>("281", "James Anders"));
            DropDownValues.Add(new KeyValuePair<string, string>("321", "Angie Wonderson"));
            DropDownValues.Add(new KeyValuePair<string, string>("221", "Hal Cloud"));
            DropDownValues.Add(new KeyValuePair<string, string>("123", "Hugh Brandley"));

            SelectedValue = "321";
                                    
            
            c1ComboBox1.LayoutUpdated += new EventHandler(c1ComboBox1_LayoutUpdated);            
            c1ComboBox1.LostFocus += new RoutedEventHandler(c1ComboBox1_LostFocus);
        }

        void c1ComboBox1_LayoutUpdated(object sender, EventArgs e)
        {
            C1.Silverlight.C1DropDown dn = ((C1.Silverlight.C1DropDown)(((System.Windows.Controls.Grid)(VisualTreeHelper.GetChild(c1ComboBox1, 0))).Children[1]));
            ((dn.Header as Grid).Children[1] as C1.Silverlight.C1TextEditableContentControl).EditTextBox.GotFocus += new RoutedEventHandler(EditTextBox_GotFocus);            
        }

        void c1ComboBox1_LostFocus(object sender, RoutedEventArgs e)
        {
            C1.Silverlight.C1DropDown dn = ((C1.Silverlight.C1DropDown)(((System.Windows.Controls.Grid)(VisualTreeHelper.GetChild(c1ComboBox1, 0))).Children[1]));

            if (c1ComboBox1.Text == "")
            {
                
                ((dn.Header as Grid).Children[0] as Border).Child = new TextBlock() { Text = "Select Item...", VerticalAlignment= System.Windows.VerticalAlignment.Center};
            }
            else
            {
                ((dn.Header as Grid).Children[0] as Border).Child = null;
            }
        }              

        void EditTextBox_GotFocus(object sender, RoutedEventArgs e)
        {
            C1.Silverlight.C1DropDown dn = ((C1.Silverlight.C1DropDown)(((System.Windows.Controls.Grid)(VisualTreeHelper.GetChild(c1ComboBox1, 0))).Children[1]));

            if (c1ComboBox1.Text == "")
            {
                ((dn.Header as Grid).Children[0] as Border).Child = null;
            }
        }
    }


}
